Перейти к основному содержимому

Интеграция с Vue

DHTMLX Booking интегрируется с Vue 3 через однофайловый компонент, который монтирует виджет внутри контейнера с ref. Это руководство проведёт вас через создание проекта Vue, установку Booking и отрисовку виджета с данными и событиями. Полная эталонная реализация доступна в примере Vue на GitHub.

Подсказка

Это руководство предполагает знакомство с основными концепциями Vue 3. Для ознакомления см. документацию Vue 3.

Создание проекта

Создайте проект Vue перед добавлением интеграции с Booking.

К сведению

Перед началом установите Node.js.

Следующая команда запускает официальный инструмент создания проекта Vue:

npm create vue@latest

Команда устанавливает и выполняет create-vue. Описание запросов и параметров см. в Vue.js Quick Start. При появлении запроса назовите проект my-vue-booking-app.

Установка зависимостей

Перейдите в каталог проекта.

Следующая команда открывает только что созданную папку приложения:

cd my-vue-booking-app

Установите зависимости и запустите сервер разработки с помощью вашего пакетного менеджера.

Следующие команды используют yarn:

yarn
yarn dev

Следующие команды используют npm:

npm install
npm run dev

Приложение запускается на localhost, например http://localhost:5173.

Добавление Booking в приложение

Остановите сервер разработки перед установкой пакета Booking, затем создайте компонент Vue, оборачивающий виджет.

Шаг 1. Установка пакета

Загрузите ознакомительный пакет Booking и следуйте инструкциям в README пакета. Ознакомительная версия активна в течение 30 дней.

Шаг 2. Создание компонента Booking

Создайте файл Booking.vue в каталоге src/components/ и выполните шаги ниже для подключения виджета.

Импорт исходных файлов

Импортируйте класс Booking и таблицу стилей, указав путь, соответствующий вашей версии дистрибутива:

  • dhx-booking-package — PRO-версия, установленная из локальной папки
  • @dhx/trial-booking — ознакомительная версия

Следующий фрагмент кода импортирует Booking из PRO-пакета:

Booking.vue
<script>
import { Booking } from 'dhx-booking-package';
import 'dhx-booking-package/dist/booking.css';
</script>

Если ваш PRO-пакет поставляется с минифицированными ресурсами, импортируйте CSS-файл как booking.min.css.

Следующий фрагмент кода импортирует Booking из ознакомительного пакета:

Booking.vue
<script>
import { Booking } from '@dhx/trial-booking';
import '@dhx/trial-booking/dist/booking.css';
</script>
К сведению

В этом руководстве используется ознакомительная версия Booking.

Настройка контейнера и инициализация Booking

Объявите контейнер-хост в шаблоне и создайте экземпляр Booking в хуке mounted(). Вызовите destructor() в unmounted(), чтобы размонтировать виджет при удалении компонента Vue.

Следующий фрагмент кода объявляет компонент Booking с контейнером через ref и хуками жизненного цикла:

Booking.vue
<script>
import { Booking } from "@dhx/trial-booking";
import "@dhx/trial-booking/dist/booking.css";

export default {
mounted() {
// создание экземпляра Booking
this.booking = new Booking(this.$refs.container, {});
},

unmounted() {
this.booking.destructor(); // размонтирование Booking
}
};
</script>

<template>
<div ref="container" class="widget"></div>
</template>

Добавление стилей

Booking требует как таблицу стилей виджета (импортированную выше), так и контейнер с заданными размерами. Установите полную высоту для страницы и контейнера виджета в главном CSS-файле проекта.

Следующий фрагмент кода устанавливает полную высоту для страницы и контейнера Booking:

main.css
/* стили страницы — используется корневой контейнер #app */
html,
body,
#app {
height: 100%;
padding: 0;
margin: 0;
}

/* контейнер Booking */
.widget {
height: 100%;
}

Загрузка данных

Для загрузки данных карточек в Booking подготовьте набор данных, соответствующий свойству data. Полный формат данных и сценарии загрузки см. в руководстве Загрузка данных.

Создайте файл data.js в каталоге src/.

Следующий фрагмент кода определяет вспомогательную функцию getData(), возвращающую пример набора данных:

data.js
export function getData() {
function getDate(addDays, hoursValue = 0, minutesValue = 0) {
const date = new Date();
const secondsValue = 0; // округление до минут
const msValue = 0;

date.setDate(date.getDate() + addDays);
date.setHours(hoursValue, minutesValue, secondsValue, msValue);

return date.getTime();
}

return [
{
id: "ee828b5d-a034-420c-889b-978840015d6a",
title: "Natalie Tyson",
category: "Therapist",
subtitle: "2 years of experience",
details: "Cleveland Clinic\n9500 Euclid Ave",
preview: "https://snippet.dhtmlx.com/codebase/data/booking/01/img/01.jpg",
price: "$35",
review: {
stars: 4,
count: 120
},
slots: [
{
from: 9,
to: 20,
days: [1, 2, 3, 4, 5]
},
{
from: 10,
to: 18,
days: [6, 0]
}
]
},
{
id: "9b037564-77be-429f-b719-eebbe499027a",
title: "Emma Johnson",
category: "Cardiologist",
subtitle: "2 years of experience",
details: "Stanford Health Care\n1468 Madison Ave",
preview: "https://snippet.dhtmlx.com/codebase/data/booking/01/img/03.jpg",
price: "$25",
review: {
stars: 5,
count: 10
},
slots: [
{
from: 14,
to: 17,
size: 30,
gap: 10
},
{
from: 12,
to: 19,
size: 50,
gap: 20,
days: [2],
dates: [getDate(0)]
},
{
from: "18:30",
to: 20,
size: 20,
gap: 20,
days: [3, 4, 5]
}
],
usedSlots: [getDate(0, 12), getDate(0, 18)]
},
// ...
];
}

Откройте App.vue, импортируйте набор данных, предоставьте его через опцию data() и передайте набор данных компоненту <Booking/> в качестве пропа.

Следующий фрагмент кода отображает компонент Booking с пропом data:

App.vue
<script>
import Booking from "./components/Booking.vue";
import { getData } from "./data";

export default {
components: { Booking },
data() {
const dataset = getData();
return { dataset };
}
};
</script>

<template>
<Booking :data="dataset" />
</template>

Откройте Booking.vue и передайте проп data в конфигурацию Booking.

Следующий фрагмент кода подключает проп к конструктору Booking:

Booking.vue
<script>
import { Booking } from "@dhx/trial-booking";
import "@dhx/trial-booking/dist/booking.css";

export default {
props: ["data"],

mounted() {
this.booking = new Booking(this.$refs.container, {
data: this.data,
// другие свойства конфигурации
});
},

unmounted() {
this.booking.destructor();
}
};
</script>

<template>
<div ref="container" class="widget"></div>
</template>

Компонент Booking теперь отображается с загруженными данными. Для дальнейшей настройки виджета передайте дополнительные свойства конфигурации — полный список см. в обзоре свойств.

Обработка событий

Действие пользователя в виджете вызывает событие. Подпишитесь на событие с помощью booking.api.on(eventName, handler), чтобы реагировать на действие. Полный список событий см. в обзоре событий.

Откройте Booking.vue и расширьте mounted() подпиской на событие.

Следующий фрагмент кода выводит в лог идентификатор слота, когда пользователь выбирает слот:

Booking.vue
<script>
// ...
export default {
// ...
mounted() {
this.booking = new Booking(this.$refs.container, {});

// вывод в лог идентификатора выбранного слота
this.booking.api.on("select-slot", (obj) => {
console.log(obj.id);
});
}
// ...
}
</script>

<!--...*/}

Запустите приложение, чтобы увидеть Booking с загруженными данными на странице.

Виджет DHTMLX Booking с загруженными данными в приложении Vue

Настройте код в соответствии с требованиями вашего проекта. Полная эталонная реализация доступна на GitHub.

Перейти к основному содержимому

Интеграция с Angular

DHTMLX Booking интегрируется с Angular через пользовательский компонент, оборачивающий конструктор виджета. Это руководство проведёт вас через создание нового проекта Angular, установку Booking и отображение виджета с данными и событиями. Полную эталонную реализацию смотрите в примере Angular на GitHub.

Подсказка

Данное руководство предполагает знакомство с основными концепциями Angular. Для введения см. документацию Angular.

Создание проекта

Создайте новое Angular-приложение с помощью Angular CLI перед добавлением интеграции с Booking.

К сведению

Перед началом установите Angular CLI и Node.js.

Следующая команда создаёт новый проект my-angular-booking-app:

ng new my-angular-booking-app
Примечание

Отключите Server-Side Rendering (SSR) и Static Site Generation (SSG/Prerendering) при появлении соответствующего запроса в CLI. Виджет Booking монтируется в DOM на стороне клиента.

Команда устанавливает все необходимые инструменты. Дополнительные команды не требуются.

Установка зависимостей

Перейдите в директорию проекта.

Следующая команда открывает папку только что созданного приложения:

cd my-angular-booking-app

Установите зависимости и запустите сервер разработки с помощью вашего пакетного менеджера.

Следующие команды используют yarn:

yarn
yarn start

Следующие команды используют npm:

npm install
npm start

Приложение запускается на localhost, например http://localhost:4200.

Добавление Booking в приложение

Остановите сервер разработки перед установкой пакета Booking, затем создайте Angular-компонент, оборачивающий виджет.

Шаг 1. Установка пакета

Загрузите пробный пакет Booking и следуйте инструкциям в README пакета. Пробная версия действует 30 дней.

Шаг 2. Создание компонента Booking

Создайте папку booking в директории src/app/ и добавьте в неё файл booking.component.ts. Выполните шаги ниже, чтобы подключить виджет.

Импорт исходных файлов

Импортируйте класс Booking, указав путь, соответствующий вашей версии дистрибутива:

  • dhx-booking-package — PRO-версия, установленная из локальной папки
  • @dhx/trial-booking — пробная версия

Следующий фрагмент кода импортирует Booking из PRO-пакета:

import { Booking } from 'dhx-booking-package';

Следующий фрагмент кода импортирует Booking из пробного пакета:

import { Booking } from '@dhx/trial-booking';
К сведению

В этом руководстве используется пробная версия Booking.

Установка контейнера и инициализация Booking

Определите хост-контейнер в шаблоне компонента и создайте экземпляр Booking в ngOnInit(). Вызовите destructor() в ngOnDestroy(), чтобы размонтировать виджет при удалении компонента Angular.

Следующий фрагмент кода объявляет компонент Booking с элементом-контейнером и хуками жизненного цикла:

booking.component.ts
import { Booking } from '@dhx/trial-booking';
import { Component, ElementRef, OnInit, ViewChild, OnDestroy, ViewEncapsulation } from '@angular/core';

@Component({
encapsulation: ViewEncapsulation.None,
selector: "booking", // используется в app.component.ts как <booking />
styleUrls: ["./booking.component.css"],
template: `<div #container className="widget"></div>`,
})

export class BookingComponent implements OnInit, OnDestroy {
// хост-контейнер для Booking
@ViewChild('container', { static: true }) booking_container!: ElementRef;

private _booking!: Booking;

ngOnInit() {
// создаём экземпляр Booking
this._booking = new Booking(this.booking_container.nativeElement, {});
}

ngOnDestroy(): void {
this._booking.destructor(); // размонтируем Booking
}
}

Добавление стилей

Booking требует как таблицы стилей виджета, так и контейнера с заданными размерами.

Создайте файл booking.component.css в директории src/app/booking/.

Следующий фрагмент кода импортирует таблицу стилей Booking и задаёт полную высоту для страницы и контейнера виджета:

booking.component.css
/* импорт стилей Booking */
@import "@dhx/trial-booking/dist/booking.css";

/* стили страницы */
html,
body {
margin: 0;
padding: 0;
height: 100%;
}

/* контейнер Booking */
.widget {
height: 100%;
}

Загрузка данных

Чтобы загрузить данные карточек в Booking, подготовьте набор данных, соответствующий свойству data. Полный формат данных и сценарии загрузки см. в руководстве Загрузка данных.

Создайте файл data.ts в директории src/app/booking/.

Следующий фрагмент кода определяет вспомогательную функцию getData(), возвращающую пример набора данных:

data.ts
export function getData() : any {
function getDate(addDays : any, hoursValue = 0, minutesValue = 0) {
const date = new Date();
const secondsValue = 0; // округляем до минут
const msValue = 0;

date.setDate(date.getDate() + addDays);
date.setHours(hoursValue, minutesValue, secondsValue, msValue);

return date.getTime();
}

return [
{
id: "ee828b5d-a034-420c-889b-978840015d6a",
title: "Natalie Tyson",
category: "Therapist",
subtitle: "2 years of experience",
details: "Cleveland Clinic\n9500 Euclid Ave",
preview: "https://snippet.dhtmlx.com/codebase/data/booking/01/img/01.jpg",
price: "$35",
review: {
stars: 4,
count: 120
},
slots: [
{
from: 9,
to: 20,
days: [1, 2, 3, 4, 5]
},
{
from: 10,
to: 18,
days: [6, 0]
}
]
},
{
id: "9b037564-77be-429f-b719-eebbe499027a",
title: "Emma Johnson",
category: "Cardiologist",
subtitle: "2 years of experience",
details: "Stanford Health Care\n1468 Madison Ave",
preview: "https://snippet.dhtmlx.com/codebase/data/booking/01/img/03.jpg",
price: "$25",
review: {
stars: 5,
count: 10
},
slots: [
{
from: 14,
to: 17,
size: 30,
gap: 10
},
{
from: 12,
to: 19,
size: 50,
gap: 20,
days: [2],
dates: [getDate(0)]
},
{
from: "18:30",
to: 20,
size: 20,
gap: 20,
days: [3, 4, 5]
},
],
usedSlots: [getDate(0, 12), getDate(0, 18)]
},
// ...
];
}

Откройте booking.component.ts, импортируйте набор данных и передайте его в конфигурацию Booking внутри ngOnInit().

Следующий фрагмент кода подключает getData() в конструктор Booking:

booking.component.ts
import { Booking } from '@dhx/trial-booking';
import { getData } from "./data"; // импортируем данные
import { Component, ElementRef, OnInit, ViewChild, OnDestroy, ViewEncapsulation } from '@angular/core';

@Component({
encapsulation: ViewEncapsulation.None,
selector: "booking",
styleUrls: ["./booking.component.css"],
template: `<div #container className="widget"></div>`,
})

export class BookingComponent implements OnInit, OnDestroy {
@ViewChild('container', { static: true }) booking_container!: ElementRef;

private _booking!: Booking;

ngOnInit() {
const data = getData(); // загружаем набор данных
this._booking = new Booking(this.booking_container.nativeElement, {
data
});
}

ngOnDestroy(): void {
this._booking.destructor();
}
}

Компонент Booking теперь отображается с загруженными данными. Для дальнейшей настройки виджета передайте дополнительные свойства конфигурации — полный список см. в Обзоре свойств.

Обработка событий

Действие пользователя в виджете вызывает событие. Подпишитесь на событие с помощью booking.api.on(eventName, handler), чтобы реагировать на это действие. Полный список событий см. в Обзоре событий.

Откройте booking.component.ts и расширьте ngOnInit() подпиской на событие.

Следующий фрагмент кода выводит в консоль идентификатор слота при его выборе пользователем:

booking.component.ts
// ...
ngOnInit() {
this._booking = new Booking(this.booking_container.nativeElement, {
start: new Date(2024, 5, 10),
});

// выводим в консоль id выбранного слота
this._booking.api.on("select-slot", (obj) => {
console.log(obj.id);
});
}

ngOnDestroy(): void {
this._booking.destructor();
}

Шаг 3. Регистрация Booking в приложении

Добавьте BookingComponent в загрузку приложения. Откройте src/app/app.component.ts и замените код по умолчанию.

Следующий фрагмент кода отображает компонент Booking внутри AppComponent:

app.component.ts
import { Component } from "@angular/core";

@Component({
selector: "app-root",
template: `<booking/>` // шаблон определён в booking.component.ts
})
export class AppComponent {
name = "";
}

Создайте app.module.ts в src/app/ и объявите оба компонента.

Следующий фрагмент кода регистрирует AppComponent и BookingComponent в корневом модуле:

app.module.ts
import { NgModule } from "@angular/core";
import { BrowserModule } from "@angular/platform-browser";

import { AppComponent } from "./app.component";
import { BookingComponent } from "./booking/booking.component";

@NgModule({
declarations: [AppComponent, BookingComponent],
imports: [BrowserModule],
bootstrap: [AppComponent]
})
export class AppModule {}

Откройте src/main.ts и выполните начальную загрузку корневого модуля.

Следующий фрагмент кода запускает приложение с AppModule:

main.ts
import { platformBrowserDynamic } from "@angular/platform-browser-dynamic";
import { AppModule } from "./app/app.module";
platformBrowserDynamic()
.bootstrapModule(AppModule)
.catch((err) => console.error(err));

Запустите приложение, чтобы увидеть Booking с загруженными данными на странице.

Виджет DHTMLX Booking с загруженными данными в приложении Angular

Настройте код в соответствии с требованиями вашего проекта. Полная эталонная реализация доступна на GitHub.

Перейти к основному содержимому

Интеграция со Svelte

DHTMLX Booking интегрируется со Svelte через однофайловый компонент, который монтирует виджет внутри привязанного контейнера. Это руководство проведёт вас через создание проекта на Svelte, установку Booking и отображение виджета с данными и событиями. Полную эталонную реализацию смотрите в примере Svelte на GitHub.

Подсказка

Это руководство предполагает знакомство с основными концепциями Svelte. Для введения см. документацию Svelte.

Создание проекта

Создайте проект на Svelte перед добавлением интеграции с Booking.

К сведению

Установите Vite (опционально) и Node.js перед началом работы.

Следующая команда запускает инструмент создания проектов Vite:

npm create vite@latest

При появлении запроса назовите проект my-svelte-booking-app.

Установка зависимостей

Перейдите в директорию проекта.

Следующая команда открывает папку только что созданного приложения:

cd my-svelte-booking-app

Установите зависимости и запустите dev-сервер с помощью вашего пакетного менеджера.

Следующие команды используют yarn:

yarn
yarn dev

Следующие команды используют npm:

npm install
npm run dev

Приложение запускается на localhost, например http://localhost:5173.

Добавление Booking в приложение

Остановите dev-сервер перед установкой пакета Booking, затем создайте компонент Svelte, который оборачивает виджет.

Шаг 1. Установка пакета

Загрузите ознакомительный пакет Booking и следуйте инструкциям в README пакета. Ознакомительная версия остаётся активной в течение 30 дней.

Шаг 2. Создание компонента Booking

Создайте файл Booking.svelte в директории src/ и выполните описанные ниже шаги для подключения виджета.

Импорт исходных файлов

Импортируйте класс Booking и таблицу стилей, указав путь, соответствующий вашему дистрибутиву:

  • dhx-booking-package — PRO-версия, установленная из локальной папки
  • @dhx/trial-booking — ознакомительная версия

Следующий фрагмент кода импортирует Booking из PRO-пакета:

Booking.svelte
<script>
import { Booking } from 'dhx-booking-package';
import 'dhx-booking-package/dist/booking.css';
</script>

Если ваш PRO-пакет поставляется с минифицированными ресурсами, импортируйте CSS-файл как booking.min.css.

Следующий фрагмент кода импортирует Booking из ознакомительного пакета:

Booking.svelte
<script>
import { Booking } from '@dhx/trial-booking';
import '@dhx/trial-booking/dist/booking.css';
</script>
К сведению

В этом руководстве используется ознакомительная версия Booking.

Настройка контейнера и инициализация Booking

Привяжите хост-контейнер с помощью bind:this и создайте экземпляр Booking внутри onMount(). Вызовите destructor() в onDestroy(), чтобы размонтировать виджет при удалении компонента Svelte.

Следующий фрагмент кода объявляет компонент Booking с привязанным контейнером и хуками жизненного цикла:

Booking.svelte
<script>
import { onMount, onDestroy } from "svelte";
import { Booking } from "@dhx/trial-booking";
import "@dhx/trial-booking/dist/booking.css";

let container; // хост-контейнер для Booking
let booking;

onMount(() => {
// создание экземпляра Booking
booking = new Booking(container, {})
});

onDestroy(() => {
booking.destructor(); // размонтирование Booking
});
</script>

<div bind:this={container} class="widget"></div>

Добавление стилей

Booking требует как таблицы стилей виджета (импортированной выше), так и контейнера с заданными размерами. Установите полную высоту для страницы и контейнера виджета в главном CSS-файле проекта.

Следующий фрагмент кода устанавливает полную высоту для страницы и контейнера Booking:

main.css
/* стили страницы; используется корневой контейнер #app */
html,
body,
#app {
height: 100%;
padding: 0;
margin: 0;
}

/* контейнер Booking */
.widget {
height: 100%;
}

Загрузка данных

Чтобы загрузить данные карточек в Booking, подготовьте набор данных, соответствующий свойству data. Полный формат данных и сценарии загрузки смотрите в руководстве Загрузка данных.

Создайте файл data.js в директории src/.

Следующий фрагмент кода определяет вспомогательную функцию getData(), возвращающую пример набора данных:

data.js
export function getData() {
function getDate(addDays, hoursValue = 0, minutesValue = 0) {
const date = new Date();
const secondsValue = 0; // округление до минут
const msValue = 0;

date.setDate(date.getDate() + addDays);
date.setHours(hoursValue, minutesValue, secondsValue, msValue);

return date.getTime();
}

return [
{
id: "ee828b5d-a034-420c-889b-978840015d6a",
title: "Natalie Tyson",
category: "Therapist",
subtitle: "2 years of experience",
details: "Cleveland Clinic\n9500 Euclid Ave",
preview: "https://snippet.dhtmlx.com/codebase/data/booking/01/img/01.jpg",
price: "$35",
review: {
stars: 4,
count: 120
},
slots: [
{
from: 9,
to: 20,
days: [1, 2, 3, 4, 5]
},
{
from: 10,
to: 18,
days: [6, 0]
}
]
},
{
id: "9b037564-77be-429f-b719-eebbe499027a",
title: "Emma Johnson",
category: "Cardiologist",
subtitle: "2 years of experience",
details: "Stanford Health Care\n1468 Madison Ave",
preview: "https://snippet.dhtmlx.com/codebase/data/booking/01/img/03.jpg",
price: "$25",
review: {
stars: 5,
count: 10
},
slots: [
{
from: 14,
to: 17,
size: 30,
gap: 10
},
{
from: 12,
to: 19,
size: 50,
gap: 20,
days: [2],
dates: [getDate(0)]
},
{
from: "18:30",
to: 20,
size: 20,
gap: 20,
days: [3, 4, 5]
}
],
usedSlots: [getDate(0, 12), getDate(0, 18)]
},
// ...
];
}

Откройте App.svelte, импортируйте набор данных и передайте его компоненту <Booking/> в качестве пропса.

Следующий фрагмент кода отображает компонент Booking с пропсом data:

App.svelte
<script>
import Booking from "./Booking.svelte";
import { getData } from "./data.js";

const dataset = getData();
</script>

<Booking data={dataset} />

Откройте Booking.svelte и передайте пропс data в конфигурацию Booking.

Следующий фрагмент кода подключает пропс к конструктору Booking:

Booking.svelte
<script>
import { onMount, onDestroy } from "svelte";
import { Booking } from "@dhx/trial-booking";
import "@dhx/trial-booking/dist/booking.css";

export let data;

let container;
let booking;

onMount(() => {
booking = new Booking(container, {
data
})
});

onDestroy(() => {
booking.destructor();
});
</script>

<div bind:this={container} class="widget"></div>

Компонент Booking теперь отображается с загруженными данными. Для дальнейшей настройки виджета передайте дополнительные свойства конфигурации — полный список смотрите в Обзоре свойств.

Обработка событий

Действие пользователя в виджете вызывает событие. Подпишитесь на событие с помощью booking.api.on(eventName, handler), чтобы реагировать на это действие. Полный список событий смотрите в Обзоре событий.

Откройте Booking.svelte и расширьте onMount() подпиской на событие.

Следующий фрагмент кода выводит в консоль ID слота при его выборе пользователем:

Booking.svelte
<script>
// ...
let booking;

onMount(() => {
booking = new Booking(container, {})

// вывод ID выбранного слота в консоль
booking.api.on("select-slot", (obj) => {
console.log(obj.id);
});
});

onDestroy(() => {
booking.destructor();
});
</script>

// ...

Запустите приложение, чтобы увидеть Booking с загруженными данными на странице.

Виджет DHTMLX Booking с загруженными данными в приложении Svelte

Настройте код в соответствии с требованиями вашего проекта. Полная эталонная реализация доступна на GitHub.

Перейти к основному содержимому

Интеграция с React

DHTMLX Booking интегрируется с React через компонент-обёртку, который монтирует виджет внутри контейнера с ref. Это руководство поможет вам создать React-проект, установить Booking и отобразить виджет с данными и событиями. Полную эталонную реализацию смотрите в примере React на GitHub.

Подсказка

Это руководство предполагает знакомство с основными концепциями React. Для знакомства с ними обратитесь к документации React.

Создание проекта

Создайте React-приложение перед добавлением интеграции с Booking. Используйте Create React App или React с Vite.

К сведению

Установите Vite (опционально) и Node.js перед началом работы.

Следующая команда создаёт новый проект my-react-booking-app с помощью Create React App:

npx create-react-app my-react-booking-app

Установка зависимостей

Перейдите в директорию проекта.

Следующая команда открывает папку созданного приложения:

cd my-react-booking-app

Установите зависимости и запустите сервер разработки с помощью вашего пакетного менеджера.

Следующие команды используют yarn:

yarn
yarn start

Следующие команды используют npm:

npm install
npm start

Приложение запускается на localhost, например http://localhost:3000.

Добавление Booking в приложение

Остановите сервер разработки перед установкой пакета Booking, затем создайте React-компонент, который оборачивает виджет.

Шаг 1. Установка пакета

Скачайте пробный пакет Booking и следуйте инструкциям в README пакета. Пробная версия активна в течение 30 дней.

Шаг 2. Создание компонента Booking

Создайте файл Booking.jsx в директории src/ и выполните описанные ниже шаги для подключения виджета.

Импорт исходных файлов

Импортируйте класс Booking и таблицу стилей, указав путь, соответствующий вашей версии дистрибутива:

  • dhx-booking-package — PRO-версия, установленная из локальной папки
  • @dhx/trial-booking — пробная версия

Следующий фрагмент кода импортирует Booking из PRO-пакета:

Booking.jsx
import { Booking } from 'dhx-booking-package';
import 'dhx-booking-package/dist/booking.css';

Если ваш PRO-пакет поставляется с минифицированными файлами, импортируйте CSS-файл как booking.min.css.

Следующий фрагмент кода импортирует Booking из пробного пакета:

Booking.jsx
import { Booking } from '@dhx/trial-booking';
import "@dhx/trial-booking/dist/booking.css";
К сведению

В этом руководстве используется пробная версия Booking.

Настройка контейнера и инициализация Booking

Объявите ref для хост-контейнера и создайте экземпляр Booking внутри useEffect(). Верните функцию очистки, которая вызывает destructor() для размонтирования виджета при размонтировании компонента React.

Следующий фрагмент кода объявляет компонент Booking с контейнером через ref и очисткой жизненного цикла:

Booking.jsx
import { useEffect, useRef } from "react";
import { Booking } from "@dhx/trial-booking";
import "@dhx/trial-booking/dist/booking.css"; // импорт стилей Booking

export default function BookingComponent(props) {
let container = useRef(); // хост-контейнер для Booking

useEffect(() => {
// создание экземпляра Booking
const booking = new Booking(container.current, {});

return () => {
booking.destructor(); // размонтирование Booking
};
}, []);

return <div ref={container} className="widget"></div>;
}

Добавление стилей

Booking требует как таблицу стилей виджета (импортированную выше), так и контейнер с заданными размерами. Установите полную высоту для страницы и контейнера виджета в основном CSS-файле проекта.

Следующий фрагмент кода устанавливает полную высоту для страницы и контейнера Booking:

index.css
/* стили страницы */
html,
body,
#root {
height: 100%;
padding: 0;
margin: 0;
}

/* контейнер Booking */
.widget {
height: 100%;
}

Загрузка данных

Чтобы загрузить данные карточек в Booking, подготовьте набор данных, соответствующий свойству data. Полный формат данных и сценарии загрузки см. в руководстве Загрузка данных.

Создайте файл data.js в директории src/.

Следующий фрагмент кода определяет вспомогательную функцию getData(), которая возвращает тестовый набор данных:

data.js
export function getData() {
function getDate(addDays, hoursValue = 0, minutesValue = 0) {
const date = new Date();
const secondsValue = 0; // округление до минут
const msValue = 0;

date.setDate(date.getDate() + addDays);
date.setHours(hoursValue, minutesValue, secondsValue, msValue);

return date.getTime();
}

return [
{
id: "ee828b5d-a034-420c-889b-978840015d6a",
title: "Natalie Tyson",
category: "Therapist",
subtitle: "2 years of experience",
details: "Cleveland Clinic\n9500 Euclid Ave",
preview: "https://snippet.dhtmlx.com/codebase/data/booking/01/img/01.jpg",
price: "$35",
review: {
stars: 4,
count: 120
},
slots: [
{
from: 9,
to: 20,
days: [1, 2, 3, 4, 5]
},
{
from: 10,
to: 18,
days: [6, 0]
}
]
},
{
id: "9b037564-77be-429f-b719-eebbe499027a",
title: "Emma Johnson",
category: "Cardiologist",
subtitle: "2 years of experience",
details: "Stanford Health Care\n1468 Madison Ave",
preview: "https://snippet.dhtmlx.com/codebase/data/booking/01/img/03.jpg",
price: "$25",
review: {
stars: 5,
count: 10
},
slots: [
{
from: 14,
to: 17,
size: 30,
gap: 10
},
{
from: 12,
to: 19,
size: 50,
gap: 20,
days: [2],
dates: [getDate(0)]
},
{
from: "18:30",
to: 20,
size: 20,
gap: 20,
days: [3, 4, 5]
}
],
usedSlots: [getDate(0, 12), getDate(0, 18)]
},
// ...
];
}

Откройте App.js, импортируйте набор данных и передайте его в компонент <Booking/> в качестве пропа.

Следующий фрагмент кода рендерит компонент Booking с пропом data:

App.js
import Booking from "./Booking";
import { getData } from "./data";

function App() {
const dataset = getData();
return <Booking data={dataset} />;
}

export default App;

Откройте Booking.jsx и передайте проп data в конфигурацию Booking.

Следующий фрагмент кода подключает проп в конструктор Booking:

Booking.jsx
import { useEffect, useRef } from "react";
import { Booking } from "@dhx/trial-booking";
import "@dhx/trial-booking/dist/booking.css";

export default function BookingComponent(props) {
let container = useRef();

useEffect(() => {
const booking = new Booking(container.current, {
data: props.data
// другие свойства конфигурации
});

return () => {
booking.destructor();
}
}, []);

return <div ref={container} className="widget"></div>;
}

Теперь компонент Booking рендерится с загруженными данными. Чтобы дополнительно настроить виджет, передайте дополнительные свойства конфигурации — полный список см. в обзоре свойств.

Обработка событий

Действие пользователя в виджете вызывает событие. Подпишитесь на событие с помощью booking.api.on(eventName, handler), чтобы реагировать на действие. Полный список событий см. в обзоре событий.

Откройте Booking.jsx и расширьте useEffect() подпиской на событие.

Следующий фрагмент кода выводит в консоль ID слота при выборе пользователем слота:

Booking.jsx
// ...
useEffect(() => {
const booking = new Booking(container.current, {});

// вывод ID выбранного слота
booking.api.on("select-slot", (obj) => {
console.log(obj.id);
});

return () => {
booking.destructor();
}
}, []);
// ...

Запустите приложение, чтобы увидеть Booking с загруженными данными на странице.

Виджет DHTMLX Booking с загруженными данными в приложении React

Адаптируйте код под требования вашего проекта. Полная эталонная реализация доступна на GitHub.